<#if ctrl.getPortletType() == 'CONTAINER'>
  <#assign portletClass = "portlet-container">
  <#assign portletHeight = "100%">
  <#assign portletWidth = "100%">
<#else>
  <#assign portletHeight = "clac(100% - 16px)">
  <#assign portletWidth = "clac(100% - 16px)">
  <#assign portletClass = "portlet">
</#if>
<template>
    <div class='${portletClass} ${srffilepath2(ctrl.getCodeName())} <#if ctrl.getPSSysCss()??> ${ctrl.getPSSysCss().getCssName()}</#if>' :style="{<#if (ctrl.getHeight?? && ctrl.getHeight() gt 0)>'height': isAdaptiveSize ? '${portletHeight}' : <#if ctrl.getHeight() == 1>'auto'<#else>'${ctrl.getHeight()?c}px'</#if>,</#if><#if (ctrl.getWidth?? && ctrl.getWidth() gt 0)>'width': isAdaptiveSize ? '${portletWidth}' : '${ctrl.getWidth()?c}px '</#if>}">
    <#if ctrl.getPortletType?? && ctrl.getPortletType()??><#t>
        <#--  视图  -->
        <#if ctrl.getPortletType() == 'VIEW' && ctrl.getPortletPSAppView?? && ctrl.getPortletPSAppView()??><#t>
        <#if ctrl.isShowTitleBar() && ctrl.getTitle()??>
        <p class='portlet-title'>
            <i class='<#if ctrl.getPSSysImage()??><#assign img=ctrl.getPSSysImage()><#if img.getCssClass()?? && (img.getCssClass()?length gt 0)>${img.getCssClass()}</#if></#if>'></i>
            ${ctrl.getTitle()}
        </p>
        </#if>
        <div class="<#if ctrl.isShowTitleBar()>portlet-with-title<#else>portlet-without-title</#if>">
        <#assign refview = ctrl.getPortletPSAppView()><#t>
        <${srffilepath2(refview.getCodeName())} :viewdata="JSON.stringify(context)" :viewDefaultUsage="false" ></${srffilepath2(refview.getCodeName())}>
        </div>
        <#--  菜单  -->
        <#elseif  ctrl.getPortletType() == 'APPMENU'><#t>
        <#if ctrl.isShowTitleBar() && ctrl.getTitle()??>
        <p class='portlet-title'>
            <i class='<#if ctrl.getPSSysImage()??><#assign img=ctrl.getPSSysImage()><#if img.getCssClass()?? && (img.getCssClass()?length gt 0)>${img.getCssClass()}</#if></#if>'></i>
            ${ctrl.getTitle()}
        </p>
        </#if>
        <div class="<#if ctrl.isShowTitleBar()>portlet-with-title<#else>portlet-without-title</#if>">
        <#assign appmenu = ctrl.getPSAppMenu()><#t>
        <@ibizindent blank=6>
        ${P.getCtrlCode(appmenu, 'CONTROL.html').code}
        </@ibizindent>
        </div>
        <#--  自定义  -->
        <#elseif  ctrl.getPortletType() == 'CUSTOM'>
        <#if ctrl.isShowTitleBar() && ctrl.getTitle()??>
        <p class='portlet-title'>
            <i class='<#if ctrl.getPSSysImage()??><#assign img=ctrl.getPSSysImage()><#if img.getCssClass()?? && (img.getCssClass()?length gt 0)>${img.getCssClass()}</#if></#if>'></i>
            ${ctrl.getTitle()}
        </p>
        </#if>
        <div class="<#if ctrl.isShowTitleBar()>portlet-with-title<#else>portlet-without-title</#if>">
        <#if ctrl.render??>
        ${ctrl.render.code}
        <#else>
        <div>无扩展插件</div>
        </#if>
        </div>
        <#--  操作栏  -->
        <#elseif  ctrl.getPortletType() == 'ACTIONBAR'>
        <#if ctrl.isShowTitleBar() && ctrl.getTitle()??>
        <p class='portlet-title'>
            <i class='<#if ctrl.getPSSysImage()??><#assign img=ctrl.getPSSysImage()><#if img.getCssClass()?? && (img.getCssClass()?length gt 0)>${img.getCssClass()}</#if></#if>'></i>
            ${ctrl.getTitle()}
        </p>
        </#if>
        <div class="<#if ctrl.isShowTitleBar()>portlet-with-title<#else>portlet-without-title</#if>">
        <#if ctrl.render??>
            ${ctrl.render.code}
        <#else>
            <app-actionbar :items="actionBarModelData" @itemClick="handleItemClick"></app-actionbar>
        </#if>
        </div>
        <#--  HTML  -->
        <#elseif  ctrl.getPortletType() == 'HTML'>
        <#if ctrl.isShowTitleBar() && ctrl.getTitle()??>
        <p class='portlet-title'>
            <i class='<#if ctrl.getPSSysImage()??><#assign img=ctrl.getPSSysImage()><#if img.getCssClass()?? && (img.getCssClass()?length gt 0)>${img.getCssClass()}</#if></#if>'></i>
            ${ctrl.getTitle()}
        </p>
        </#if>
        <div class="<#if ctrl.isShowTitleBar()>portlet-with-title<#else>portlet-without-title</#if>">
        <iframe src="<#if ctrl.getPageUrl()??>${ctrl.getPageUrl()}</#if>" style="height: <#if ctrl.getHeight() gt 0>${ctrl.getHeight()?c}<#else>400</#if>px;width: 100%;border-width: 1px;"></iframe>
        </div>         
        <#--  容器  -->
        <#elseif  ctrl.getPortletType() == 'CONTAINER'><#t>
        <#list ctrl.getPSPortlets() as portlet><#t>
            <#if portlet.getPortletType?? && portlet.getPortletType()??><#t>
            <#assign layout='TABLE_24COL'><#if portlet.getPSLayoutPos()??><#if portlet.getPSLayoutPos().getParentPSLayout()??><#assign layout='${portlet.getPSLayoutPos().getParentPSLayout().getLayout()}'></#if></#if><#t>
            <#assign LayoutPos = portlet.getPSLayoutPos()><#t>
            <#if layout == 'FLEX' >
            <div style = '<#if layout == 'FLEX' > display : flex; <#if ctrl.getFlexAlign()??> justify-content :${ctrl.getFlexAlign()};</#if> <#if ctrl.getFlexDir()??> flex-direction:${ctrl.getFlexDir()};</#if> <#if ctrl.getFlexVAlign()??>align-items:${ctrl.getFlexVAlign()};</#if></#if> '>
            </#if>
            <#if layout == 'TABLE_24COL' && LayoutPos??><#t>
            <i-col<#if LayoutPos.getColXS() != -1> :xs="{ span: ${LayoutPos.getColXS()}, offset: <#if LayoutPos.getColXSOffset() != -1>${LayoutPos.getColXSOffset()}<#else>0</#if> }"</#if><#if LayoutPos.getColSM() != -1> :sm="{ span: ${LayoutPos.getColSM()}, offset: <#if LayoutPos.getColSMOffset() != -1>${LayoutPos.getColSMOffset()}<#else>0</#if> }"</#if><#if LayoutPos.getColMD() != -1> :md="{ span: ${LayoutPos.getColMD()}, offset: <#if LayoutPos.getColMDOffset() != -1>${LayoutPos.getColMDOffset()}<#else>0</#if> }"</#if><#if LayoutPos.getColLG() != -1> :lg="{ span: ${LayoutPos.getColLG()}, offset: <#if LayoutPos.getColLGOffset() != -1>${LayoutPos.getColLGOffset()}<#else>0</#if> }"</#if>>
                <div class="portlet-without-title">
                <@ibizindent blank=18>
                ${P.getCtrlCode(portlet, 'CONTROL.html').code}
                </@ibizindent>
                </div>
            </i-col>
            <#else>
            <div class="portlet-without-title">
            <@ibizindent blank=18>
            ${P.getCtrlCode(portlet, 'CONTROL.html').code}
            </@ibizindent>
            </div>
            </#if>
            <#if layout == 'FLEX' >
            </div>
            </#if>
            </#if>
        </#list>
        <#--  其他部件  -->
        <#elseif ctrl.getContentPSControl()??><#t>
        <#if ctrl.isShowTitleBar() && ctrl.getTitle()??>
        <p class='portlet-title'>
            <i class='<#if ctrl.getPSSysImage()??><#assign img=ctrl.getPSSysImage()><#if img.getCssClass()?? && (img.getCssClass()?length gt 0)>${img.getCssClass()}</#if></#if>'></i>
            ${ctrl.getTitle()}
        </p>
        </#if>
        <div class="<#if ctrl.isShowTitleBar()>portlet-with-title<#else>portlet-without-title</#if>">
        <#assign control = ctrl.getContentPSControl()><#t>
        <!-- 测试 -->
        <@ibizindent blank=6>
        ${P.getCtrlCode(control, 'CONTROL.html').code}
        </@ibizindent>
        </div>
        </#if>
    </#if>
    </div>
</template>
<#ibizinclude>
../@MACRO/CONTROL/CONTROL_PORTLET-HEADER-BASE.vue.ftl
</#ibizinclude>

    <#if ctrl.getPortletType() == 'ACTIONBAR'>
    /**
     * 操作栏模型数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public actionBarModelData:any[] =[
        <#if  ctrl.getPSAppViewLogics?? && ctrl.getPSAppViewLogics()??>
        <#list ctrl.getPSAppViewLogics() as appViewLogic>
        { viewlogicname:"${appViewLogic.name}",
        <#if appViewLogic.getPSAppViewUIAction?? && appViewLogic.getPSAppViewUIAction()??>
        <#assign viewUIAction = appViewLogic.getPSAppViewUIAction()/>
        <#if viewUIAction.getPSUIAction?? && viewUIAction.getPSUIAction()??>
        <#assign uiaction = viewUIAction.getPSUIAction() />
        actionName:"${uiaction.getCaption()}",
        <#if uiaction.getPSAppCounter?? && uiaction.getPSAppCounter()??>
        <#assign counter = uiaction.getPSAppCounter() />
        counterService:this.${srfclassname('${counter.getCodeName()}')}counterservice,
        <#if uiaction.getCounterId()??>counterId:"${uiaction.getCounterId()}",</#if>
        </#if>
        </#if>
        </#if>
        }<#if appViewLogic_has_next>,</#if>
        </#list>
        </#if>
    ];
    <#if ctrl.getPortletType?? && ctrl.getPortletType()?? && ctrl.getPortletType() == "TOOLBAR" >
    <#assign toolbar = ctrl.getContentPSControl()/>
    ${P.getCtrlCode(toolbar, 'CONTROL.vue').code}
    </#if>

    /**
     * 触发界面行为
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public handleItemClick($event:any){
    <#if  ctrl.getPSAppViewLogics?? && ctrl.getPSAppViewLogics()??>
    <#list ctrl.getPSAppViewLogics() as appViewLogic>
        if(Object.is($event,'${appViewLogic.name}')){
            this.${appViewLogic.name}(null);
        }
    </#list>
    </#if>
    }
    </#if>

    /**
     * 是否自适应大小
     *
     * @returns {boolean}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    @Prop({default: false})public isAdaptiveSize!: boolean;

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public getData(): any {
        return {};
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof ${srfclassname('${ctrl.codeName}')}Base
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                const refs: any = this.$refs;
                Object.keys(refs).forEach((_name: string) => {
                    this.viewState.next({ tag: _name, action: action, data: data });
                });
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof ${srfclassname('${ctrl.codeName}')}Base
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        <#if destroyed_block??>
        ${destroyed_block}
        </#if>
    }

<#ibizinclude>
../@MACRO/CONTROL/CONTROL_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/CONTROL/CONTROL-BASE.style.ftl
</#ibizinclude>